# remirepo/Fedora spec file for php-zendframework-zend-progressbar
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    f5b885453c4c789ddc86e395ae553df5b4148d15
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-progressbar
%global php_home     %{_datadir}/php
%global library      ProgressBar
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.7.0
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-json": "^2.6.1",
#        "zendframework/zend-session": "^2.8.5"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# ignore max version
BuildRequires: (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-session)        >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)        < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
# remirepo:10
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)        <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)        >= 2.8.5
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.8
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^3.2.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# remirepo:4
%else
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
%endif
# From composer, "suggest": {
#        "zendframework/zend-json": "Zend\\Json component",
#        "zendframework/zend-session": "To support progressbar persistent"
Suggests:       php-autoloader(%{gh_owner}/zend-json)
Suggests:       php-autoloader(%{gh_owner}/zend-session)
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.1
Requires:       php-date
Requires:       php-pcre
Requires:       php-spl
# apc and uploadprogress are optional

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\ProgressBar is a component to create and update progress bars in
different environments. It consists of a single backend, which outputs
the progress through one of the multiple adapters. On every update, it
takes an absolute value and optionally a status message, and then calls
the adapter with some precalculated values like percentage and estimated
time left.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Json/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" php71 php72 php73 php74; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Oct 18 2019 Remi Collet <remi@remirepo.net> - 2.7.0-1
- update to 2.7.0 (no change)
- raise dependency on zend-stdlib >= 3.2.1

* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 2.6.0-2
- update to 2.6.0
- raise dependency on PHP 5.6
- use range dependencies on F27+
- switch to phpunit6 or phpunit7

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 2.5.2-4
- switch from zend-loader to fedora/autoloader

* Wed Mar  2 2016 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise dependency on PHP >= 5.5
- raise dependency on zend-stdlib >= 2.7

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
